import { isFunction, generateAction, getTypePrefix, toConstant } from '../utils';

export default function makeAction(prefix, name, payload) {
  var type = '' + getTypePrefix(prefix) + toConstant(name);
  var finalPayload = isFunction(payload) ? payload : generateAction;

  var action = function action() {
    return {
      type: type, payload: finalPayload.apply(undefined, arguments)
    };
  };

  action.toString = function () {
    return type;
  };

  return action;
}