import reduceReducers from 'reduce-reducers';
import { isString } from '../utils';
import createInstance from './createInstance';

/**
 * Create Redux reducer from Class
 * @param {Function|Object} Reducer
 * @param {Object|String} [initialStateOrPrefix]
 * @param {String} [prefix]
 * @return {Function} Reducer
 */
export default function createReducer(Reducer, initialStateOrPrefix, prefix) {
  var hasPrefix = isString(prefix);
  var initialState = hasPrefix ? initialStateOrPrefix : {};
  var typePrefix = !hasPrefix && isString(initialStateOrPrefix) ? initialStateOrPrefix : prefix;

  var _createInstance = createInstance(Reducer, typePrefix),
      reducers = _createInstance.reducers,
      reducerInitialState = _createInstance.initialState;

  var reducer = reduceReducers.apply(undefined, reducers);

  return function () {
    var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : reducerInitialState || initialState;
    var action = arguments[1];
    return reducer(state, action);
  };
}