import { getTypePrefix } from '../utils';

export default function makeActionHandler(reducerHandler, typePrefix, actionType, initialState) {
  var actionCreatorType = '' + getTypePrefix(typePrefix) + actionType;

  return function () {
    var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
    var action = arguments[1];
    return actionCreatorType === action.type ? reducerHandler(state, action.payload) : state;
  };
}