'use strict';

exports.__esModule = true;
exports.default = makeActionHandler;

var _utils = require('../utils');

function makeActionHandler(reducerHandler, typePrefix, actionType, initialState) {
  var actionCreatorType = '' + (0, _utils.getTypePrefix)(typePrefix) + actionType;

  return function () {
    var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
    var action = arguments[1];
    return actionCreatorType === action.type ? reducerHandler(state, action.payload) : state;
  };
}